// A subclass of RemoteEvent for lease events.

package corejini.chapter10;

import com.sun.jini.lease.LeaseRenewalEvent;
import net.jini.core.lease.Lease;
import net.jini.core.event.RemoteEvent;

public class RemoteLeaseRenewalEvent extends RemoteEvent {
    protected Lease lease;
    protected long expiration;
    protected Exception exception;
    
    public RemoteLeaseRenewalEvent(long eventID,
                                   long seqNum,
                                   LeaseRenewalService renewer,
                                   Lease lease, long expiration,
                                   Exception exception) {
        super(renewer, eventID, seqNum, null);
        this.lease = lease;
        this.expiration = expiration;
        this.exception = exception;
    }
    public Lease getLease() {
        return lease;
    }
    public long getExpiration() {
        return expiration;
    }
    public Exception getException() {
        return exception;
    }
}
