// this is the actual admin object that gets returned to clients.
package corejini.chapter12;

import net.jini.core.entry.Entry; 
import net.jini.core.discovery.LookupLocator;
import net.jini.admin.JoinAdmin;
import com.sun.jini.admin.DestroyAdmin;
import com.sun.jini.admin.StorageLocationAdmin;
import java.io.IOException;
import java.io.Serializable;
import java.rmi.RemoteException;

public class LeaseAdminProxy implements JoinAdmin, DestroyAdmin, 
    StorageLocationAdmin, Serializable {
    protected AdminLeaseService.RemoteLeaseAdmin remote;
    
    LeaseAdminProxy(AdminLeaseService.RemoteLeaseAdmin remote) {
        this.remote = remote;
    }
    
    // implement destroyadmin
    public void destroy() throws RemoteException {
        remote.destroy();
    }
    
    // implement storagelocationadmin
    public void setStorageLocation(String loc) throws IOException, 
        RemoteException {
        remote.setStorageLocation(loc);
    }
    
    public String getStorageLocation() throws RemoteException {
        return remote.getStorageLocation();
    }
    
    // implement JoinAdmin
    public Entry[] getLookupAttributes() throws RemoteException {
        return remote.getLookupAttributes();
    }
    public void addLookupAttributes(Entry[] attrs) throws RemoteException {
        remote.addLookupAttributes(attrs);
    }
    public void modifyLookupAttributes(Entry[] tmpls, Entry[] attrs)
        throws RemoteException {
        remote.modifyLookupAttributes(tmpls, attrs);
    }
    public String[] getLookupGroups() throws RemoteException {
        return remote.getLookupGroups();
    }
    public void addLookupGroups(String[] groups) throws RemoteException {
        remote.addLookupGroups(groups);
    }
    public void removeLookupGroups(String[] groups) throws RemoteException {
        remote.removeLookupGroups(groups);
    }
    public void setLookupGroups(String[] groups) throws RemoteException {
        remote.setLookupGroups(groups);
    }
    public LookupLocator[] getLookupLocators() throws RemoteException {
        return remote.getLookupLocators();
    }
    public void addLookupLocators(LookupLocator[] locs) throws RemoteException {
        remote.addLookupLocators(locs);
    }
    public void removeLookupLocators(LookupLocator[] locs) throws RemoteException {
        remote.removeLookupLocators(locs);
    }
    public void setLookupLocators(LookupLocator[] locs) throws RemoteException {
        remote.setLookupLocators(locs);
    }
}
