// A subclass of registration that holds a
// vector of to-be-delivered events.

package corejini.chapter14;

import java.io.Serializable;
import java.rmi.MarshalledObject;
import java.util.Vector;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;

class EventMailboxRegistration extends Registration implements Serializable {
    protected Vector mailbox = new Vector();
    
    EventMailboxRegistration(Object cookie, RemoteEventListener listener,
                             MarshalledObject data, long expiration) {
        super(cookie, listener, data, expiration);
    }
    
    // Override cancelled to null the mailbox
    protected void cancelled() {
        mailbox = null;
    }
    
    Vector getMailbox() {
        return mailbox;
    }
    void appendEvent(RemoteEvent ev) {
        mailbox.addElement(ev);
    }
    Vector getAndFlushMailbox() {
        Vector rv = getMailbox();
        mailbox = new Vector();
        return rv;
    }
}
